<template>
  <div class="filter-wrapper" :class="{ show }">
    <transition name="fade">
      <div class="filter-panel" v-if="show">
        <div class="container">
          <div class="categories" ref="scroll">
            <div class="categories-wrapper">
              <div
                class="category-wrapper"
                v-for="categoryName in categories"
                :key="categoryName"
                @click="$emit('changed', categoryName)"
              >
                <div
                  class="category"
                  :style="categoryStyle(categoryName)"
                  :class="categoryClasses(categoryName)"
                >
                  <span class="category-name">{{
                    $t(`restaurantTypes.${categoryName}`)
                  }}</span>
                </div>
              </div>
              <div class="category-placeholder"></div>
            </div>
          </div>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
import { mapState } from "vuex";
import BScroll from "better-scroll";
import wheel from "@/lib/better-scroll-vertical-wheel";

export default {
  props: {
    show: {
      type: Boolean
    },
    category: {
      type: String,
      required: true
    }
  },

  computed: {
    ...mapState(["isMobile"]),

    categories() {
      return [
        "all",
        "chinese",
        "japanese",
        "korean",
        "american",
        "vegi",
        "southeastasia",
        "italian",
        "hk",
        "bbq",
        "cafe",
        "teppanyaki",
        "hotpot",
        "steak",
        "allucaneat",
        "family"
      ];
    },

    placeholders() {
      var n = 5;
      var i = n - (this.categories.length % n);
      const result = [];
      while (i--) {
        result.push(i);
      }
      return result;
    }
  },

  methods: {
    categoryStyle(typ) {
      if (typ === "all") {
        return {};
      }
      return {
        "background-image": `url('/static/images/restaurant-types/${typ}@2x.jpg')`
      };
    },

    categoryClasses(typ) {
      return {
        active: typ === this.category
      };
    },

    initScroll() {
      if (this.$refs.scroll) {
        this.scroll = wheel(
          new BScroll(this.$refs.scroll, {
            scrollX: true,
            click: true,
            eventPassthrough: "vertical"
          })
        );
      }
    }
  },

  updated() {
    this.initScroll();
  }
};
</script>

<style lang="scss" scoped>
.filter-wrapper {
  user-select: none;
  transition: all 0.2s;

  &.show {
    margin-bottom: 86px;

    @include media-breakpoint-down(sm) {
      margin-bottom: 94px;
    }
  }
}

.filter-selected {
  cursor: pointer;
}

.filter-panel {
  position: absolute;
  top: 100%;
  left: 0;
  width: 100%;
  background: rgba(255, 255, 255, 0.9);
}

.fade-enter-active,
.fade-leave-active {
  transition: all 0.5s;
  top: 100%;
  transition-delay: 0.1s;

  @include media-breakpoint-up(md) {
    transition-delay: 0;
  }
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
  top: 0%;
}

.category {
  cursor: pointer;
  position: relative;
  background-color: $color-skm-red;
  background-position: center;
  background-repeat: no-repeat;
  background-size: cover;
  width: 110px;
  padding-bottom: 66.666%;
  border-radius: 2px;
  overflow: hidden;

  @include media-breakpoint-up(md) {
    width: 100%;
  }

  &::after {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background-image: linear-gradient(
      to bottom,
      transparent,
      rgba(0, 0, 0, 0.5)
    );
  }

  &.active::after {
    background-color: rgba(210, 29, 29, 0.85);
  }
}

.filter-selected-name {
  display: inline-block;
  vertical-align: middle;
}

.categories-wrapper {
  display: inline-block;
  white-space: nowrap;

  @include media-breakpoint-up(md) {
    display: flex;
    flex-wrap: wrap;
    margin-left: -7px;
  }
}

.categories {
  display: block;
  padding-top: 7px;
  padding-bottom: 7px;
  white-space: nowrap;
  overflow: hidden;

  @include media-breakpoint-down(sm) {
    padding-top: 10px;
    padding-bottom: 10px;
  }
}

.category-wrapper {
  display: inline-block;
  box-sizing: border-box;
  padding-right: 7px;

  @include media-breakpoint-up(md) {
    flex: 1 1 25%;
    padding: 7px;
  }

  @include media-breakpoint-up(lg) {
    flex: 1 1 20%;
  }
}

.category-placeholder {
  @include media-breakpoint-up(md) {
    display: none;
    flex: 1 1 0%;
  }

  @include media-breakpoint-up(lg) {
    display: block;
    flex: 1 1 80%;
    padding: 7px;
  }
}

.category-name {
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  color: $color-white;
  text-align: center;
  z-index: 1;
  padding: 10px 0;
  font-size: 14px;

  @include media-breakpoint-up(md) {
    padding: 16px 0;
    font-size: 16px;
    font-weight: 300;
  }
}
</style>
